<?php

/**
 * BBCode with style
 *
 * @package BBCodeWithStyle
 * @version 1.5.1
 * @author davidhs
 * @copyright 2010-2015 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License http://creativecommons.org/licenses/by/3.0/
 */

if (!defined('SMF'))
	die('Hacking attempt...');

// Adds bbc codes.
function bbcws_bbc_codes(&$codes)
{
	$has_ncode_imageresizer = false;
	foreach ($codes as $code)
	{
		$has_ncode_imageresizer = 'img' == $code['tag'] && strpos($code['content'], 'NcodeImageResizer') !== false;
		if ($has_ncode_imageresizer)
			break; // Exit foreach.
	}
	if ($has_ncode_imageresizer)
	{
		$codes[] = array(
			'tag' => 'img',
			'type' => 'unparsed_content',
			'parameters' => array(
				'alt' => array('optional' => true),
				'width' => array('optional' => true, 'value' => ' width="$1"', 'match' => '(\d+)'),
				'height' => array('optional' => true, 'value' => ' height="$1"', 'match' => '(\d+)'),
				'class' => array('optional' => true, 'quoted' => true, 'value' => ' $1'),
				'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
				'rotateangle' => array('optional' => true, 'match' => '(\d+)'),
				'rotatebgcolor' => array('optional' => true, 'match' => '(#[\da-fA-F]{3}|#[\da-fA-F]{6}|[A-Za-z]{1,20}|\d{1,3},?\d{1,3},?\d{1,3})'),
				'flip' => array('optional' => true, 'match' => '(horizontal|vertical)'),
			),
			'content' => '<img src="$1" alt="{alt}"{width}{height}{style} border="0" onload="NcodeImageResizer.createOn(this);" class="bbc_img{class}" />' . "\n" . '{rotateangle}' . "\n" . '{rotatebgcolor}' . "\n" . '{flip}',
			'validate' => create_function('&$tag, &$data, $disabled', '
				global $boardurl;

				$is_disabled_content = \'($1)\' == $tag[\'content\'];
				if (!$is_disabled_content)
				{
					list ($html, $rotateangle, $rotatebgcolor, $flip) = explode(\'' . "\n" . '\', $tag[\'content\']);
					$tag[\'content\'] = $html;
				}
				$data = strtr($data, array(\'<br />\' => \'\'));
				if (strpos($data, \'http://\') !== 0 && strpos($data, \'https://\') !== 0)
					$data = \'http://\' . $data;
				if (!$is_disabled_content && (!empty($rotateangle) || !empty($flip)))
				{
					$data = $boardurl . \'/Sources/Subs-BBCodeWithStyle-Image.php?image=\' . urlencode($data);
					if (!empty($rotateangle))
					{
						$data .= \'&amp;rotateangle=\' . $rotateangle;
						if (!empty($rotatebgcolor))
						{
							if ($rotatebgcolor[0] == \'#\')
								$rotatebgcolor[0] = \'-\';
							$data .= \'&amp;rotatebgcolor=\' . $rotatebgcolor;
						}
					}
					if (!empty($flip))
						$data .= \'&amp;flip=\' . $flip;
				}
			'),
			'disabled_content' => '($1)',
		);
	}
	else
	{
		$codes[] = array(
			'tag' => 'img',
			'type' => 'unparsed_content',
			'parameters' => array(
				'alt' => array('optional' => true),
				'width' => array('optional' => true, 'value' => ' width="$1"', 'match' => '(\d+)'),
				'height' => array('optional' => true, 'value' => ' height="$1"', 'match' => '(\d+)'),
				'class' => array('optional' => true, 'quoted' => true, 'value' => ' $1'),
				'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
				'rotateangle' => array('optional' => true, 'match' => '(\d+)'),
				'rotatebgcolor' => array('optional' => true, 'match' => '(#[\da-fA-F]{3}|#[\da-fA-F]{6}|[A-Za-z]{1,20}|\d{1,3},?\d{1,3},?\d{1,3})'),
				'flip' => array('optional' => true, 'match' => '(horizontal|vertical)'),
			),
			'content' => '<img src="$1" alt="{alt}"{width}{height}{style} class="bbc_img resized{class}" />' . "\n" . '{rotateangle}' . "\n" . '{rotatebgcolor}' . "\n" . '{flip}',
			'validate' => create_function('&$tag, &$data, $disabled', '
				global $boardurl;

				$is_disabled_content = \'($1)\' == $tag[\'content\'];
				if (!$is_disabled_content)
				{
					list ($html, $rotateangle, $rotatebgcolor, $flip) = explode(\'' . "\n" . '\', $tag[\'content\']);
					$tag[\'content\'] = $html;
				}
				$data = strtr($data, array(\'<br />\' => \'\'));
				if (strpos($data, \'http://\') !== 0 && strpos($data, \'https://\') !== 0)
					$data = \'http://\' . $data;
				if (!$is_disabled_content && (!empty($rotateangle) || !empty($flip)))
				{
					$data = $boardurl . \'/Sources/Subs-BBCodeWithStyle-Image.php?image=\' . urlencode($data);
					if (!empty($rotateangle))
					{
						$data .= \'&amp;rotateangle=\' . $rotateangle;
						if (!empty($rotatebgcolor))
						{
							if ($rotatebgcolor[0] == \'#\')
								$rotatebgcolor[0] = \'-\';
							$data .= \'&amp;rotatebgcolor=\' . $rotatebgcolor;
						}
					}
					if (!empty($flip))
						$data .= \'&amp;flip=\' . $flip;
				}
			'),
			'disabled_content' => '($1)',
		);
	}

	$codes[] = array(
		'tag' => 'div',
		'parameters' => array(
			'class' => array('optional' => true, 'quoted' => true, 'value' => ' class="$1"'),
			'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
		),
		'before' => '<div{class}{style}>',
		'after' => '</div>',
		'block_level' => true,
	);
	$codes[] = array(
		'tag' => 'hr',
		'type' => 'closed',
		'parameters' => array(
			'class' => array('optional' => true, 'quoted' => true, 'value' => ' class="$1"'),
			'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
		),
		'content' => '<hr{class}{style} />',
		'block_level' => true,
	);
	$codes[] = array(
		'tag' => 'li',
		'parameters' => array(
			'class' => array('optional' => true, 'quoted' => true, 'value' => ' class="$1"'),
			'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
		),
		'before' => '<li{class}{style}>',
		'after' => '</li>',
		'trim' => 'outside',
		'require_parents' => array('list'),
		'block_level' => true,
		'disabled_before' => '',
		'disabled_after' => '<br />',
	);
	$codes[] = array(
		'tag' => 'list',
		'parameters' => array(
			'class' => array('optional' => true, 'quoted' => true, 'value' => ' $1'),
			'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
		),
		'before' => '<ul class="bbc_list{class}"{style}>',
		'after' => '</ul>',
		'trim' => 'inside',
		'require_children' => array('li', 'list'),
		'block_level' => true,
	);
	$codes[] = array(
		'tag' => 'list',
		'parameters' => array(
			'type' => array('match' => '(none|disc|circle|square|decimal|decimal-leading-zero|lower-roman|upper-roman|lower-alpha|upper-alpha|lower-greek|lower-latin|upper-latin|hebrew|armenian|georgian|cjk-ideographic|hiragana|katakana|hiragana-iroha|katakana-iroha)'),
			'class' => array('optional' => true, 'quoted' => true, 'value' => ' $1'),
			'style' => array('optional' => true, 'quoted' => true, 'value' => ' $1'),
		),
		'before' => '<ul class="bbc_list{class}" style="list-style-type: {type};{style}">',
		'after' => '</ul>',
		'trim' => 'inside',
		'require_children' => array('li'),
		'block_level' => true,
	);
	$codes[] = array(
		'tag' => 'span',
		'parameters' => array(
			'class' => array('optional' => true, 'quoted' => true, 'value' => ' class="$1"'),
			'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
		),
		'before' => '<span{class}{style}>',
		'after' => '</span>',
	);
	$codes[] = array(
		'tag' => 'table',
		'parameters' => array(
			'border' => array('optional' => true, 'value' => ' border="$1"', 'match' => '(\d+)'),
			'class' => array('optional' => true, 'quoted' => true, 'value' => ' $1'),
			'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
		),
		'before' => '<table class="bbc_table{class}"{border}{style}>',
		'after' => '</table>',
		'trim' => 'inside',
		'require_children' => array('tr'),
		'block_level' => true,
	);
	$codes[] = array(
		'tag' => 'td',
		'parameters' => array(
			'colspan' => array('optional' => true, 'value' => ' colspan="$1"', 'match' => '(\d+)'),
			'rowspan' => array('optional' => true, 'value' => ' rowspan="$1"', 'match' => '(\d+)'),
			'class' => array('optional' => true, 'quoted' => true, 'value' => ' class="$1"'),
			'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
		),
		'before' => '<td{colspan}{rowspan}{class}{style}>',
		'after' => '</td>',
		'require_parents' => array('tr'),
		'trim' => 'outside',
		'block_level' => true,
		'disabled_before' => '',
		'disabled_after' => '',
	);
	$codes[] = array(
		'tag' => 'tr',
		'parameters' => array(
			'class' => array('optional' => true, 'quoted' => true, 'value' => ' class="$1"'),
			'style' => array('optional' => true, 'quoted' => true, 'value' => ' style="$1"'),
		),
		'before' => '<tr{class}{style}>',
		'after' => '</tr>',
		'require_parents' => array('table'),
		'require_children' => array('td'),
		'trim' => 'both',
		'block_level' => true,
		'disabled_before' => '',
		'disabled_after' => '',
	);
}

// Adds bbc buttons.
function bbcws_bbc_buttons(&$bbc_tags)
{
	global $txt;

	$bbc_tags[1][] = array();
	$bbc_tags[1][] = array(
		'image' => 'div',
		'code' => 'div',
		'before' => '[div style=""]',
		'after' => '[/div]',
		'description' => $txt['style_paragraph']
	);
	$bbc_tags[1][] = array(
		'image' => 'span',
		'code' => 'span',
		'before' => '[span style=""]',
		'after' => '[/span]',
		'description' => $txt['style_character']
	);
}

?>
